﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Практическая__5
{
    /// <summary>
    /// Логика взаимодействия для AdminUserData.xaml
    /// </summary>
    public partial class AdminUserData : Page
    {
        public AdminUserData()
        {
            InitializeComponent();
            DGUserData.ItemsSource = BaseConnect.kotBase.tbUsers.ToList();
        }

        private void BTFilterClick(object sender, RoutedEventArgs e)
        {
            if (SPFilter.Visibility == Visibility.Visible)
            {
                noVis();
            }
            else
            {
                noVis();
                BTFilter.Content = "Скрыть выбор сортировки";
                SPFilter.Visibility = Visibility.Visible;
                BTNoFilter.Visibility = Visibility.Visible;
            }
        }

        private void noVis()
        {
            BTFilter.Content = "Выбрать сортировку";
            SPFilter.Visibility = Visibility.Collapsed;
            BTNoFilter.Visibility = Visibility.Collapsed;
            BTNoSearch.Visibility = Visibility.Collapsed;
            GBSearchLastName.Visibility = Visibility.Collapsed;
            GBSearchLog.Visibility = Visibility.Collapsed;
        }
        private void BTNoFilterClick(object sender, RoutedEventArgs e)
        {
            DGUserData.ItemsSource = BaseConnect.kotBase.tbUsers.ToList();
        }
        private void BTLastNameUpClick(object sender, RoutedEventArgs e)
        {
            DGUserData.ItemsSource = BaseConnect.kotBase.tbUsers.ToList().OrderBy(tb => tb.lastName).ToList();
        }

        private void BTLastNameDownClick(object sender, RoutedEventArgs e)
        {
            DGUserData.ItemsSource = BaseConnect.kotBase.tbUsers.ToList().OrderByDescending(tb => tb.lastName).ToList();
        }

        private void BTGenderMClick(object sender, RoutedEventArgs e)
        {
            DGUserData.ItemsSource = BaseConnect.kotBase.tbUsers.ToList().Where(tb => tb.tbGender.nameGender == "Мужской").ToList();
        }

        private void DTGenderFClick(object sender, RoutedEventArgs e)
        {
            DGUserData.ItemsSource = BaseConnect.kotBase.tbUsers.ToList().Where(tb => tb.tbGender.nameGender == "Женский").ToList();
        }

        private void BTSearchLogClick(object sender, RoutedEventArgs e)
        {
            noVis();
            BTNoSearch.Visibility = Visibility.Visible;
            GBSearchLog.Visibility = Visibility.Visible;
            DGUserData.ItemsSource = BaseConnect.kotBase.tbUsers.ToList();
        }

        private void BTSearchLastNameClick(object sender, RoutedEventArgs e)
        {
            noVis();
            BTNoSearch.Visibility = Visibility.Visible;
            GBSearchLastName.Visibility = Visibility.Visible;
            DGUserData.ItemsSource = BaseConnect.kotBase.tbUsers.ToList();
        }

        private void BTNoSearchClick(object sender, RoutedEventArgs e)
        {
            DGUserData.ItemsSource = BaseConnect.kotBase.tbUsers.ToList();
            if (GBSearchLog.Visibility == Visibility.Visible)
            {
                TBSearchLog.Text = "";
            }
            else
            {
                TBSearchLastName.Text = "";
            }
        }

        private void TBSearchLastNameKeyUp(object sender, KeyEventArgs e)
        {
            DGUserData.ItemsSource = BaseConnect.kotBase.tbUsers.ToList().Where(tb => tb.lastName.StartsWith(TBSearchLastName.Text)).ToList();
        }

        private void TBSearchLogKeyUp(object sender, KeyEventArgs e)
        {
            DGUserData.ItemsSource = BaseConnect.kotBase.tbUsers.ToList().Where(tb => tb.login.StartsWith(TBSearchLog.Text)).ToList();
        }

        private void BTHomeClick(object sender, RoutedEventArgs e)
        {
            FrameClass.frameMain.NavigationService.Navigate(new AdminMain());
        }
    }
}
