﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Практическая__5
{
    /// <summary>
    /// Логика взаимодействия для JewelryAdd.xaml
    /// </summary>
    public partial class JewelryAdd : Page
    {
        private double _price;
        private bool onCreate;
        private tbJewelry thisJewelry = new tbJewelry();
        public JewelryAdd()
        {
            InitializeComponent();
            init();
            onCreate = true;
        }

        public JewelryAdd(int index)
        {
            InitializeComponent();
            init();
            thisJewelry = BaseConnect.kotBase.tbJewelry.Where(tb => tb.idJewelry == index).ToList().Last();
            onCreate = false;
            fill();
        }
        private void init()
        {
            CBType.ItemsSource = BaseConnect.kotBase.tbTypeJewelry.ToList();
            CBType.DisplayMemberPath = "nameType";
            CBType.SelectedValuePath = "idType";

            CBMetal.ItemsSource = BaseConnect.kotBase.tbMaterial.ToList();

            //обнуление всех значений
            List<tbMaterial> list = BaseConnect.kotBase.tbMaterial.ToList();
            foreach (tbMaterial elem in list)
            {
                elem.checkMaterial = false;
                elem.countMaterial = 0;
            }
        }
        private void fill()
        {
            BTAdd.Content = "Редактировать украшение";
            //код для обработки картинки
            tbTypeJewelry type = BaseConnect.kotBase.tbTypeJewelry.Where(tb => tb.idType == thisJewelry.idType).ToList().Last();
            CBType.SelectedItem = type;
            TBName.Text = thisJewelry.name;
            TBDescripyion.Text = thisJewelry.description;

            List<tbCompositionJewelry> listComposition = BaseConnect.kotBase.tbCompositionJewelry.Where(tb => tb.idJewelry == thisJewelry.idJewelry).ToList();
            if (listComposition.Count > 0)
            {
                try
                {
                    foreach (tbMaterial elem in CBMetal.Items)
                    {
                        tbCompositionJewelry composition = listComposition.Where(tb => tb.tbBatchMaterial.tbMaterial.idMaterial == elem.idMaterial).ToList().LastOrDefault();
                        if (composition != null)
                        {
                            elem.checkMaterial = true;
                            elem.countMaterial = composition.count;
                            LVMaterial.Items.Add(elem);
                        }
                    }
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.Message);
                }
            }

        }
        private void BTBackClick(object sender, RoutedEventArgs e)
        {
            MessageBoxResult result = MessageBox.Show("Вы действительно хотите перейти на Страницу просмотра украшений? Введенные Вами данные не сохраняться", "Перейти на страницу просмотра украшений", MessageBoxButton.YesNo, MessageBoxImage.Information);
            if (result == MessageBoxResult.Yes)
            {
                FrameClass.frameMain.NavigationService.Navigate(new JewelryMain());
            }
        }
        private void BTBackHomeClick(object sender, RoutedEventArgs e)
        {
            MessageBoxResult result = MessageBox.Show("Вы действительно хотите перейти на Главную? Введенные Вами данные не сохраняться", "Перейти на Главную", MessageBoxButton.YesNo, MessageBoxImage.Information);
            if (result == MessageBoxResult.Yes)
            {
                FrameClass.frameMain.NavigationService.Navigate(new AdminMain());
            }

        }
        private void BTAddClick(object sender, RoutedEventArgs e)
        {
            calckPrice();

            if (CheckJewelryData.check(thisJewelry))
            {
                add(); 
            }
            else
            {
               MessageBoxResult result = MessageBox.Show("Некоторые поля до сих пор не заполнены, Вы правда хотите добавить украшение?", "Не все поля заполнены", MessageBoxButton.YesNo, MessageBoxImage.Information);

                if(result == MessageBoxResult.Yes)
                {
                    add();
                }
            }
        }
        private void add()
        {
            thisJewelry.name = TBName.Text;
            thisJewelry.description = TBDescripyion.Text;
            thisJewelry.price = _price;
            thisJewelry.idType = ((tbTypeJewelry)CBType.SelectedItem).idType;
            thisJewelry.image = null; // !! пофиксить !!

            if (onCreate)
            {
                BaseConnect.kotBase.tbJewelry.Add(thisJewelry);
            }

            List<tbCompositionJewelry> listComposition = BaseConnect.kotBase.tbCompositionJewelry.Where(tb => tb.idJewelry == thisJewelry.idJewelry).ToList();
            if (listComposition.Count > 0)
            {
                foreach (tbCompositionJewelry elem in listComposition)
                {
                    BaseConnect.kotBase.tbCompositionJewelry.Remove(elem);
                }
            }
            //запись
            foreach (tbMaterial elem in LVMaterial.Items)
            {
                if (elem.countMaterial >= 0)
                {
                    tbBatchMaterial batch = BaseConnect.kotBase.tbBatchMaterial.Where(tb => tb.idMaterial == elem.idMaterial).ToList().Last();
                    tbCompositionJewelry newComposition = new tbCompositionJewelry()
                    {
                        idJewelry = thisJewelry.idJewelry,
                        count = elem.countMaterial,
                        idBatch = batch.idBatch
                    };
                    BaseConnect.kotBase.tbCompositionJewelry.Add(newComposition);
                }
            }

            BaseConnect.kotBase.SaveChanges();

            if (onCreate)
            {
                MessageBox.Show("Украшение добавлено");
            }
            else
            {
                MessageBox.Show("Изменения об украшении внесены");
            }

            FrameClass.frameMain.NavigationService.Navigate(new JewelryMain());
        }
        private void AvailabilityChecked(object sender, RoutedEventArgs e)
        {
            CheckBox cb = (CheckBox)sender;
            int index = Convert.ToInt32(cb.Uid);
            tbMaterial elem = BaseConnect.kotBase.tbMaterial.Where(tb => tb.idMaterial == index).FirstOrDefault();
            LVMaterial.Items.Add(elem);
        }
        private void AvailabilityUnchecked(object sender, RoutedEventArgs e)
        {
            CheckBox cb = (CheckBox)sender;
            int index = Convert.ToInt32(cb.Uid);
            tbMaterial elem = BaseConnect.kotBase.tbMaterial.Where(tb => tb.idMaterial == index).FirstOrDefault();
            elem.countMaterial = 0;
            LVMaterial.Items.Remove(elem);
        }
        private void calckPrice()
        {
            _price = 0;

            foreach (tbMaterial elem in LVMaterial.Items)
            {
                tbBatchMaterial actualPrice = BaseConnect.kotBase.tbBatchMaterial.Where(tb => tb.idMaterial == elem.idMaterial).ToList().Last();
                if (actualPrice != null)
                {
                    _price += elem.countMaterial * actualPrice.price;
                }
            }

            //налоговые вычиты + доход
            _price += (_price * 0.2) + (_price * 0.5);
        }
        private void BTAddPhotoClick(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("Добавление фотографий временно не доступно", "Невозможно загрузить фото", MessageBoxButton.OK, MessageBoxImage.Information);
        }
    }
}
