﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Практическая__5
{
    /// <summary>
    /// Логика взаимодействия для UserProfile.xaml
    /// </summary>
    public partial class UserProfile : Page
    {
        private tbUsers user = UserData.User;
        public UserProfile()
        {
            InitializeComponent();
            init();
        }
        private void init()
        {
            TBFirstName.Text = user.firstName;
            TBLastName.Text = user.lastName;
            TBMiddleName.Text = user.middleName;
            TBGender.Text = user.tbGender.nameGender;
            TBDateofBirthday.Text = user.dateBirthday.ToString("dd MMMM yyyy");
            tbImageUser imageUser = BaseConnect.kotBase.tbImageUser.FirstOrDefault(tb => tb.idImage == user.idImage);
            if (imageUser != null)
            {
                byte[] arrImage = imageUser.image;
                ConvertImage.convertByteToImage(arrImage, ImageAvatar);
            }
            if(user.idRole != 1)
            {
                BtnMenu.Visibility = Visibility.Collapsed;
            }
        }

        private void BtnUserDataClick(object sender, RoutedEventArgs e)
        {
            ChangeUserData windows = new ChangeUserData();
            windows.ShowDialog();
            FrameClass.frameMain.NavigationService.Navigate(new UserProfile());
        }

        private void BtnUserPhotoClick(object sender, RoutedEventArgs e)
        {
            ChangeUserPhoto windows = new ChangeUserPhoto();
            windows.ShowDialog();
            FrameClass.frameMain.NavigationService.Navigate(new UserProfile());
        }

        private void BtnUserAutentificClick(object sender, RoutedEventArgs e)
        {
            ChangeUserAuthentication windows = new ChangeUserAuthentication();
            windows.ShowDialog();
        }

        private void BtnMenuClick(object sender, RoutedEventArgs e)
        {
            FrameClass.frameMain.NavigationService.Navigate(new AdminMain());
        }
    }
}
