﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Практическая__5
{
    /// <summary>
    /// Логика взаимодействия для ChangeUserPhoto.xaml
    /// </summary>
    public partial class ChangeUserPhoto : Window
    {
        tbUsers user = new tbUsers();
        List<tbImageUser> imagesList;
        int idImage = 0;
        public ChangeUserPhoto()
        {
            InitializeComponent();
            user = UserData.User;
        }
        private void loadImage()
        {
            if (imagesList.Count > 0)
            {
                byte[] arrImage = imagesList[idImage].image;
                ConvertImage.convertByteToImage(arrImage, Image);
            }
        }
        private void BtnBackPhotoClick(object sender, RoutedEventArgs e)
        {
            if (idImage == 0)
            {
                idImage = imagesList.Count - 1;
            }
            else idImage--;
            loadImage();
        }

        private void BtnNextPhotoClick(object sender, RoutedEventArgs e)
        {
            if (idImage == imagesList.Count-1)
            {
                idImage = 0;
            }
            else idImage++;
            loadImage();
        }

        private void BtnAddClick(object sender, RoutedEventArgs e)
        {
            user.idImage = imagesList[idImage].idImage;
            BaseConnect.kotBase.SaveChanges();
            this.Close();
            MessageBox.Show("Фото успешно обновлено", "", MessageBoxButton.OK, MessageBoxImage.Information);
        }

        private void BtnAddPhotoClick(object sender, RoutedEventArgs e)
        {
            try
            {
                OpenFileDialog OFD = new OpenFileDialog();
                OFD.ShowDialog();
                string file = OFD.FileName;
                tbImageUser _image = new tbImageUser();
                _image.idUser = user.idUser;
                _image.image = File.ReadAllBytes(file);
                BaseConnect.kotBase.tbImageUser.Add(_image);
                BaseConnect.kotBase.SaveChanges();
                user.idImage = _image.idImage;
                BaseConnect.kotBase.SaveChanges();
                this.Close();
                MessageBox.Show("Фото успешно загружено", "Успешно", MessageBoxButton.OK, MessageBoxImage.Information);
            }
            catch
            {
                MessageBox.Show("Не удалось загрузить фото", "Ошибка загрузки фото", MessageBoxButton.OK, MessageBoxImage.Error);
            }

        }

        private void BtnAddManyPhotoClick(object sender, RoutedEventArgs e)
        {
            try
            {

                OpenFileDialog OFD = new OpenFileDialog();
                OFD.Multiselect = true;
                if (OFD.ShowDialog() == true)
                {
                    foreach (string file in OFD.FileNames)
                    {
                        tbImageUser _image = new tbImageUser();
                        _image.idUser = user.idUser;
                        _image.image = File.ReadAllBytes(file);
                        BaseConnect.kotBase.tbImageUser.Add(_image);
                    }
                }
                BaseConnect.kotBase.SaveChanges();
                this.Close();
                MessageBox.Show("Фото успешно загружено", "Успешно", MessageBoxButton.OK, MessageBoxImage.Information);
            }
            catch
            {
                MessageBox.Show("Не удалось загрузить фото", "Ошибка загрузки фото", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void BtnOldPhotoClick(object sender, RoutedEventArgs e)
        {
            imagesList = BaseConnect.kotBase.tbImageUser.Where(tb => tb.idUser == user.idUser).ToList();
            if (imagesList.Count > 0)
            {
                loadImage();
                SPButton.Visibility = Visibility.Collapsed;
                SPPhoto.Visibility = Visibility.Visible;
            }
            else
            {
                MessageBox.Show("Вы не можете выбрать фото из старых, так как у вас нет фото", "Сообщение об ошбке", MessageBoxButton.OK, MessageBoxImage.Exclamation);
            }
        }

        private void BtnBackClick(object sender, RoutedEventArgs e)
        {
            SPPhoto.Visibility = Visibility.Collapsed;
            SPButton.Visibility = Visibility.Visible;
        }
    }
}
